using System;
using System.Collections ;
using System.Collections.Specialized ;

namespace shobonjtag
{
	/// <summary>
	/// foCXp[^`NX interface JtagDevice pč܂
	///
	/// xc2s100_tq144 ̃foCXp[^`
	/// </summary>
	public class xc2s100_tq144 : JtagDevice
	{
		/// <summary>
		/// CXgNVe[u
		/// </summary>
		static StringDictionary inst ;

		/// <summary>
		/// CXgNVe[u(Hashtable)ĕԂ
		/// </summary>
		/// <returns>e[û</returns>
		static StringDictionary CreateInstruction() {
			StringDictionary sd = new StringDictionary() ;
			//		"SAMPLE  (00001)," &
			sd.Add( "SAMPLE","00001") ;
			//		"INTEST  (00111)," &
			sd.Add( "INTEST","00111") ;
			//		"USERCODE(01000)," &
			sd.Add( "USERCODE","01000") ;
			//		"IDCODE  (01001)," &
			sd.Add( "IDCODE","01001") ;
			//		"HIGHZ   (01010)," &
			sd.Add( "HIGHZ","01010") ;
			//		"JSTART  (01100)," & -- Not available during configuration with another mode.
			sd.Add( "JSTART","01100") ;
			//		"RESERVED(00110)," &
			sd.Add( "RESERVED","00110") ;
			//		"CFG_OUT (00100)," & -- Not available during configuration with another mode.
			sd.Add( "CFG_OUT","00100") ;
			//		"CFG_IN  (00101)," & -- Not available during configuration with another mode.
			sd.Add( "CFG_IN","00101") ;
			//		"USER2   (00011)," & -- Not available until after configuration
			sd.Add( "USER2","00011") ;
			//		"USER1   (00010)," & -- Not available until after configuration
			sd.Add( "USER1","00010") ;
			//		"EXTEST  (00000)," &
			sd.Add( "EXTEST","00000") ;
			//		"BYPASS (11111)";
			sd.Add( "BYPASS","11111") ;
			return sd ;
		}

		public xc2s100_tq144()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
			if (inst == null) {
				inst = CreateInstruction() ;
			}
		}

		#region JtagDevice o

		public String LSINAME {
			get {
				return "Spartan2 - XC2S100(TQFP144)" ;
			}
		}

		public double TAP_SCAN_CLOCK {
			get {
				return 33.0e6 ;
			}
		}

		public int INSTRUCTION_LENGTH {
			get {
				return 5 ;
			}
		}

		public StringDictionary INSTRUCTION_OPCODE {
			get {
				return inst ; // RXgN^łƍĕԂ
			}
		}

		public String INSTRUCTION_CAPTURE {
			get {
				return "XXX01" ;
			}
		}

		public int BOUNDARY_LENGTH {
			get {
				return 734;
			}
		}

		public String GetInstruction(String instType) {
			return inst[instType] ;
		}

		#endregion
	}
}
